/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_OBSPADRAO                                                */
/* Tabela : OBSPADRAO                                                         */
/*                                                                            */
/* Criao:                                                                   */
/* 14/05/2004 - RENATA DINIZ                                                  */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_OBSPADRAO
BEFORE INSERT OR UPDATE OR DELETE
ON OBSPADRAO FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUOBSP := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDOBSPADRAO,0) <> NVL(:NEW.CDOBSPADRAO,0)) THEN
         :NEW.DTULTATUOBSP := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('OBSPADRAO', '', 'CDOBSPADRAO='||:OLD.CDOBSPADRAO||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE OBSPADRAO MODIFY DTULTATUOBSP DEFAULT SYSDATE
/

