const ZeedhiAPIConstructor = require('zeedhi-functional-test-api');
const z = new ZeedhiAPIConstructor(browser, protractor);
const Helper = require('teknisa-helper');
const geralPage = new Helper.geral();
const loginPage = new Helper.login();
const codigoEspecificadorSTPage = require('../../../page-objects/parametrizacao/documentos fiscais/codigoEspecificadorST.po.js');
const j = require('../../../json/leitorJson.po');

describe('Tela codigoEspecificadorST', () => {
    beforeEach(() => {
        browser.get('http://erpteste.teknisa.com/login/');
        loginPage.login(j.getValor('login'), j.getValor('senha'));
        codigoEspecificadorSTPage.abrir();
        z.component.footer.clickRightActionByLabel('Filtrar', true);
    });

    afterEach(() => {
        z.component.menu.open();
        z.component.menu.clickByLabel('Sair');
        z.component.alert.clickButton('Sim');
    });

    it('Acessar a tela Código Especificador de ST', () => {
        expect(z.component.header.getTitle()).toBe('Código Especificador de Substituição Tributária');
    });

    it('Editar Código Especificador de ST', () => {
        geralPage.filterIt(j.getValor('dscest01'));
        geralPage.clickGrid('DSCEST', j.getValor('dscest01'), '8029887373258485096294', false);
        codigoEspecificadorSTPage.editarCodigoEspST(j.getValor('cdncmshutil01'), j.getValor('dscest02'));
        geralPage.filterIt(j.getValor('dscest02'));
        expect(geralPage.gridHasText('8029887373258485096294', j.getValor('dscest02'), 4)).toBe(j.getValor('dscest02'));
    });

    it('Adicionar Segmento de Mercado 30', () => {
        geralPage.trocarAba('Segmento de Mercado');
        codigoEspecificadorSTPage.adicionarSegmentoMercado(j.getValor('cdsegmento01'), j.getValor('dssegmento01'));
        geralPage.clickSalvar();
        geralPage.filterIt(j.getValor('dssegmento01'));
        expect(geralPage.gridHasText('8029887371000474269314', j.getValor('dssegmento01'), 1)).toBe(j.getValor('dssegmento01'));
    });

    it('Adicionar Segmento de Mercado 31', () => {
        geralPage.trocarAba('Segmento de Mercado');
        codigoEspecificadorSTPage.adicionarSegmentoMercado(j.getValor('cdsegmento02'), j.getValor('dssegmento02'));
        geralPage.clickSalvar();
        geralPage.filterIt(j.getValor('dssegmento02'));
        expect(geralPage.gridHasText('8029887371000474269314', j.getValor('dssegmento02'), 1)).toBe(j.getValor('dssegmento02'));
    });

    it('Adicionar Segmento de Mercado 32', () => {
        geralPage.trocarAba('Segmento de Mercado');
        codigoEspecificadorSTPage.adicionarSegmentoMercado(j.getValor('cdsegmento03'), j.getValor('dssegmento03'));
        geralPage.clickSalvar();
        geralPage.filterIt(j.getValor('dssegmento03'));
        expect(geralPage.gridHasText('8029887371000474269314', j.getValor('dssegmento03'), 1)).toBe(j.getValor('dssegmento03'));
    });

    it('Editar Segmento de Mercado 32', () => {
        geralPage.trocarAba('Segmento de Mercado');
        geralPage.filterIt(j.getValor('dssegmento03'));
        geralPage.clickGrid('DSSEGMENTO', j.getValor('dssegmento03'), '8029887371000474269314', false);
        codigoEspecificadorSTPage.editarSegmentoMercado(j.getValor('dssegmento04'));
        geralPage.filterIt(j.getValor('dssegmento04'));
        expect(geralPage.gridHasText('8029887371000474269314', j.getValor('dssegmento04'), 1)).toBe(j.getValor('dssegmento04'));
    });

    it('Excluir Segmento de Mercado 31', () => {
        geralPage.trocarAba('Segmento de Mercado');
        geralPage.filterIt(j.getValor('dssegmento02'));
        geralPage.clickGrid('DSSEGMENTO', j.getValor('dssegmento02'), '8029887371000474269314', false);
        codigoEspecificadorSTPage.excluirSegmentoMercado(j.getValor('dssegmento02'));
        geralPage.filterIt(j.getValor('dssegmento02'));
        expect(geralPage.gridHasText('8029887371000474269314', j.getValor('dssegmento02'), 1)).toBeUndefined(j.getValor('dssegmento02'));
    });

    it('Adicionar Código Especificado de ST 3910', () => {
        codigoEspecificadorSTPage.adicionarCodigoEspST(j.getValor('cditem01'), j.getValor('cdcest01'), j.getValor('cdncmshutil02'), j.getValor('dscest03'));
        geralPage.clickSalvar();
        geralPage.filterIt(j.getValor('dscest03'));
        expect(geralPage.gridHasText('8029887373258485096294', j.getValor('dscest03'), 4)).toBe(j.getValor('dscest03'));
    });

    it('Adicionar Código Especificado de ST 3911', () => {
        codigoEspecificadorSTPage.adicionarCodigoEspST(j.getValor('cditem02'), j.getValor('cdcest02'), j.getValor('cdncmshutil03'), j.getValor('dscest04'));
        geralPage.clickSalvar();
        geralPage.filterIt(j.getValor('dscest04'));
        expect(geralPage.gridHasText('8029887373258485096294', j.getValor('dscest04'), 4)).toBe(j.getValor('dscest04'));
    });

    it('Excluir  Código Especificado de ST 3910', () => {
        geralPage.filterIt(j.getValor('dscest03'));
        geralPage.clickGrid('DSCEST', j.getValor('dscest03'), '8029887373258485096294', false);
        codigoEspecificadorSTPage.excluirCodigoEspST(j.getValor('dscest03'));
        geralPage.filterIt(j.getValor('dscest03'));
        expect(geralPage.gridHasText('8029887373258485096294', j.getValor('dscest03'), 4)).toBeUndefined(j.getValor('dscest03'));
    });
});
